

(defun c:BLOCK_KONVERT ( / SPIN UPDATE_BLOCK UPDATE_BLOCKS)

                                                                       ;.... lokale Funktionen definieren

;; --------------------------------------------------------------------------------------------------- ;;
;; -- SPIN : Funktion zur Spinradausgabe in der Kommandozeile (Kleiner Gimmick)                     -- ;;
;; --        Aufruf (Spin SYM)   mit SYM als bergeordneter Variable                                -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
(defun Spin (SYM / )
  (setq SYM   (cond ((= SYM "-" ) "\\")
                    ((= SYM "\\") "|" )
                    ((= SYM "|" ) "/" )
                    ((= SYM "/" ) "-" )
                    (T            "-" )))
  (princ (strcat "\rScanning... " SYM "  "))
  SYM
)
;; --------------------------------------------------------------------------------------------------- ;;


  
;; --------------------------------------------------------------------------------------------------- ;;
;; -- UPDATE_BLOCK : ndert den ersten Block der bergebenen Blockliste entsprechend den Vorgaben   -- ;;
;; --                .. Farbe auf "VONLAYER" und Linientyp auf "VONLAYER"                           -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
(defun UPDATE_BLOCK( BLOCKLISTE / BLOCKDEF BLOCKNAME BLOCKELEMENT OBJEKTDATEN SPINSYM )  
  (if (=(type BLOCKLISTE) 'LIST)                                                       ; Parameter o.k. ?
    (progn      
      (setq BLOCKNAME (car BLOCKLISTE))                   ; Aktuell bearbeiteter Block = erster aus Liste
      (setq BLOCKLISTE(cdr BLOCKLISTE))                            ; ... Rest als BLOCKLISTE Weitermerken
    
      (if(setq BLOCKDEF (tblsearch "BLOCK" BLOCKNAME))          ; Blockdefinition zum Blocknamen auslesen
	(progn          	  
          (if (and (/=(logand(cdr(assoc 70 BLOCKDEF))1)1) ; ist Block kein unbenannter Block (Bemassung.)
                   (/= (logand(cdr(assoc 70 BLOCKDEF))4)4))                       ; und kein XREF, dann..
            (progn
              (setq BLOCKELEMENT (cdr (assoc -2 BLOCKDEF)))             ; Adresse der Blockelemente holen
              (while BLOCKELEMENT            ; und solange nicht alle Blockelemente abgearbeitet sind ...
                (if (=(cdr(assoc 0 (entget BLOCKELEMENT))) "INSERT"); Ist BLOCKELEMENT ein Block, dann...
                  (progn
                    (setq BLOCKNAME(cdr(assoc 2(entget BLOCKELEMENT))))  ;BLOCKNAME des Unterblocks holen
                    (if (not (member BLOCKNAME BLOCKLISTE));wenn dieser nicht in der Blockliste vorhanden
                      (if (not BLOCKLISTE)                               ; wenn Blockliste vorhanden ... 
                        (setq BLOCKLISTE(append BLOCKLISTE(list BLOCKNAME)));dann BLOCKNAME darin ablegen
	  	        (setq BLOCKLISTE (list BLOCKNAME))           ; sonst BLOCKLISTE erzeugen und dito
                      )                                     
                    ) 
                  )
                )                                      ; end [IF BLOCKELEMENT selber ein BLOCK ("INSERT")
                ; wenn Blockelement kein Unterblock ist..................................................
                (setq OBJEKTDATEN (entget BLOCKELEMENT))                          ; Elementdaten auslesen
                (if(assoc 62 OBJEKTDATEN)                             ; Objektfarbe auf "VONLAYER" setzen
                   (setq OBJEKTDATEN(subst(cons 62 256)(assoc 62 OBJEKTDATEN)OBJEKTDATEN))
                )
                (if(assoc 6 OBJEKTDATEN)                         ; Objekt-Linientyp auf "VONLAYER" setzen
                   (setq OBJEKTDATEN(subst(cons 6 "BYLAYER")(assoc 6 OBJEKTDATEN)OBJEKTDATEN)) 
                )
                (if(assoc 370 OBJEKTDATEN)                                   ; Objekt-Linienstrke setzen
                  ;(setq OBJEKTDATEN(subst(cons 370 -2)(assoc 370 OBJEKTDATEN)OBJEKTDATEN)) ;  "vonBLOCK"
                  ;(setq OBJEKTDATEN(subst(cons 370 -2)(assoc 370 OBJEKTDATEN)OBJEKTDATEN)) ;   "Vorgabe"
                  (setq OBJEKTDATEN                                                     ; auf "von LAYER"
                    (list  (reverse(cdr(member(assoc 370 OBJEKTDATEN) (reverse OBJEKTDATEN))))
                                   (cdr(member(assoc 370 OBJEKTDATEN)OBJEKTDATEN)))
                  )      
                )



	        ; (setq OBJEKTDATEN(subst (cons 8 "0")(assoc 8 OBJEKTDATEN)OBJEKTDATEN)) ;auf Layer "0"
		
                (entmod OBJEKTDATEN)                         ; Objektdaten in Zeichnungsdatenbank updaten
                (setq BLOCKELEMENT (entnext BLOCKELEMENT)) ; nchstes Blockelement holen, Blockende="nil"
	    
                (setq SPINSYM (Spin SPINSYM))    ; und als Gimmick: eine schne Kommandozeilenausgabe ;-)
              )                                                                 ;end [WHILE BLOCKELEMENT]
            )	  
          ); .........................................................end [IF ..kein unbenannter Block..]
        )	
      )                                               ; end [IF BLOCKDEFINITION konnte ausgelesen werden]
    )            
    (setq BLOCKLISTE nil)                         ; bei falschem Parametertyp BLOCKLISTE auf "nil" setzen
  ); .......................................................................... end [BLOCKLISTE = Liste] 
  BLOCKLISTE                                        ; Liste mit allen gefundenen Blocknamen zurckliefern
)                                                                                           ; end [DEFUN]
;; --------------------------------------------------------------------------------------------------- ;;



;; --------------------------------------------------------------------------------------------------- ;;
;; -- UPDATE_BLOCKS : ndert die Elemente aller in der Zeichnung gefundenen Blcke, bzw. der vom    -- ;;
;; --                 Anwender ausgewhlten Blcke entsprechend ==> Siehe oben                      -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
(defun UPDATE_BLOCKS( / OLDCMD BLOCKNAME BLOCK BLOCKLISTE MODUS INDEX AUSWAHL)
  (setq OLDCMD (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)                                              ; Bildschirmausgabe bei "Command" aus
  (command "._undo" "m")                                          ; Markierung fr "Zurck-Befehl" setzen

  (initget "G A")
  (setq MODUS (getkword (strcat "\n<G>anze Zeichnung oder <A>usgewhlte Blcke: <G> ")))
  (if (not MODUS) (setq MODUS "G"))                                  ; Vorgabe bei "Enter"-Eingabe setzen
  (if (= (strcase MODUS) "G")                                         ; die ganze Zeichnung bearbeiten...
    (while (setq BLOCKNAME(tblnext "BLOCK" (null BLOCKNAME)))        ; solange Blcke in der Zeichnung...
      (UPDATE_BLOCK (list(cdr(assoc 2 BLOCKNAME))))                                ; ... Blcke "updaten"
    )
      
    (progn                                               ; sonst gewhlte Blcke (oder nichts) bearbeiten
      (princ "\nZu bearbeitende(n) Block(s) whlen: ")
      (if(setq AUSWAHL (ssget '((0 . "INSERT"))))          ; Blockauswahl vom Nutzer bereitstellen lassen
        (progn
          (setq INDEX 0)                                                      ; Auswahlindex auf 0 setzen
          (repeat (sslength AUSWAHL)                              ; Auswahl durchlaufen und abarbeiten...
            (setq BLOCK(cdr(assoc 2 (entget(ssname AUSWAHL INDEX)))))                ; Blockname auslesen
            (if BLOCKLISTE
              (setq BLOCKLISTE (append BLOCKLISTE (list BLOCK)))                ; .. und in Liste ablegen
              (setq BLOCKLISTE (list BLOCK))
	    )               
	    (setq INDEX(1+ INDEX))                            ; Auswahlindex erhhen und nchsten Block..
          )                                                                                ; end [REPEAT]
          (while BLOCKLISTE                                                   ;... und Blockliste updaten
            (setq BLOCKLISTE (UPDATE_BLOCK BLOCKLISTE))
          )	   
        )
      )                                                                              ; end [IF AUSWAHL..]
    )  
  )                                                                                      ; end [IF MODUS]
  
  (command "._regen")                                                            ; Zeichnung regenerieren
  (princ "\n......... und Fertig")
  (setvar "CMDECHO" OLDCMD) 
  (princ)                                                                         ; ohne Rckgabe beenden
)                                                                                           ; end [DEFUN]
;; --------------------------------------------------------------------------------------------------- ;;


  
  ; .... Rest der "KOMMANDIERTEN" FUNKTION"
  (UPDATE_BLOCKS)
  (princ)
)
;; --------------------------------------------------------------------------------------------------- ;;

(princ "\n Starten mit : BLOCK_KONVERT\n")